#include "myRF.h"

static void Tim0SetValue(uint16_t u16Value);
static uint16_t Tim0GetValue(void);

void Tim0SetValue(uint16_t u16Value)
{
    
    TL0 = u16Value;
    TH0 = (u16Value >> 8);
}

uint16_t Tim0GetValue(void)
{
    
    return TH0 * 256 + TL0;
}

void RfInit(void)
{
    CKCON |= (1 << 3);
    TMOD &= ~(0x0F);
    TMOD |= 0x01;
    TR0 = 1;
    
    RF_PIN_INIT;
}

uint32_t RfDecode(void)
{
    uint32_t u32Result = 0;
    uint8_t u8Count = 0;
    uint8_t u8TimeOut = 0;
    
    if (RF_PIN) {
        return 0;
    }
    
    Tim0SetValue(0);
    u8TimeOut = 0;
    u8Count = 0;
    while (1) {
        if (RF_PIN) {
            break;
        }
        while (Tim0GetValue() < 16000) {
        }
        Tim0SetValue(0);
        ++u8Count;
        if (u8Count > 11) {
            u8TimeOut = 1;
            break;
        }
    }
    
    if (u8TimeOut) {
        return 0;
    }
    
    if (u8Count < 9) {
        return 0;
    }
    
    u8Count = 0;
    u32Result = 0;
    while (1) {
        Tim0SetValue(0);
        u8TimeOut = 0;
        while (1) {
            if (!RF_PIN) {
                break;
            }
            if (Tim0GetValue() > 20000) {
                u8TimeOut = 1;
                break;
            }
        }
        if (u8TimeOut) {
            return 0;
        }
        if (Tim0GetValue() > 8000) {
            u32Result <<= 1;
            u32Result |= 0x01;
        } else {
            u32Result <<= 1;
        }
        
        Tim0SetValue(0);
        u8TimeOut = 0;
        while (1) {
            if (RF_PIN) {
                break;
            }
            if (Tim0GetValue() > 20000) {
                u8TimeOut = 1;
                break;
            }
        }
        if (u8TimeOut) {
            return 0;
        }
        ++u8Count;
        if (u8Count == 24) {
            break;
        }
    }
    
    return u32Result;
}
